# [.MK]OpenVMS.MMS.  This file is .included from [.platform]'platform'.mms
# (where 'platform' is OpenVMS_Alpha_n_m or OpenVms_VAX_n_m).  The platform
# specific file sets the macro, $(POSIX_LIB_DEPEND) used below.

# Obviously, OpenVMS.MMS is redundant (since MMS only runs on VMS).
# This is because the overall structure of the omniORB2 for VMS
# build system is based on the standard build.  It was hoped that the build
# could have been redone in GNUmake using the POSIX shell.  Alas, Digital has
# decided to drop support for the POSIX shell so that may never happen.

OMNIORB2_IDL_LC_FLAGS = -l
OMNIORB2_IDL_ANY_FLAGS = -a
OMNIORB2_IDL_ONLY = omniidl2
OMNIORB2_IDL = "$(OMNIORB2_IDL_ONLY) ""$(OMNIORB2_IDL_ANY_FLAGS)"""

OMNITHREAD_LIB_DEPEND = omnilib:omnithread$(DebugSuffix).olb $(POSIX_LIB_DEPEND)
OMNITHREAD_LIB = omnilib:omnithread$(DebugSuffix).olb omnilib:share.opt

# set compiler switch and library for floating point option.

# enforce mutual exclusion of D_FLOAT|G_FLOAT|IEEE_FLOAT:
.IFDEF D_FLOAT
FloatType = D
.ENDIF

.IFDEF G_FLOAT
FloatType = G
.ENDIF

.IFDEF IEEE_FLOAT
FloatType = IEEE
.ENDIF

# handle default case:
.IFDEF D_FLOAT
.ELSE
# ifndef D_FLOAT
.IFDEF G_FLOAT
.ELSE
# ifndef G_FLOAT
.IFDEF IEEE_FLOAT
.ELSE
# ifndef IEEE_FLOAT

.IFDEF ALPHA
# Alpha default
FloatType = G
.ELSE
# VAX default
FloatType = D
.ENDIF	! Alpha vs VAX

.ENDIF	! IEEE_FLOAT else clause
.ENDIF	! G_FLOAT else clause
.ENDIF	! D_FLOAT else clause

CORBA_CPPFLOAT = /Float=$(FloatType)_Float
CORBA_FLOATLIB = omnilib:omniorb2$(FloatType)Float$(DebugSuffix).olb

CORBA_LIB_DEPEND = omnilib:omniORB2$(DebugSuffix).olb\
 $(CORBA_FLOATLIB)\
 $(OMNITHREAD_LIB_DEPEND)
CORBA_LIB = omnilib:omniORB2$(DebugSuffix).olb\
 $(CORBA_FLOATLIB)\
 $(OMNITHREAD_LIB)

CORBA_CPPFLAGS = $(CORBA_CPPFLOAT)
CORBA_CPPINCLUDES = [],omni:
OMNIORB2_IDL_FLAGS = "-IomniIdls:"

Export = @$(top)mk]Export.dcl

# ExportHeader differs from other Export rules in that you give the full path of
# the target only.

ExportHeader = $(Export) \
'f$parse("$@","","","name")''f$parse("$@","","","type")' \
'f$parse("$@","","","device")''f$parse("$@","","","directory")'

ExportExecutable = $(Export) $(MMS$SOURCE) $(EXPORT_TREE)$(BINDIR)]
ExportLibrary = $(Export) $(MMS$SOURCE) $(EXPORT_TREE)$(LIBDIR)]

# rule to create initial dependency file initially or after a veryclean

CreateMms = @$(top)mk]CreateMms.dcl

