.ifdef INITIALIZE_MMS

all ::

.else

CXXSRCS = echo_i.cc echoclt.cc \
          tstexcept_i.cc tstexceptclt.cc \
          refp_i.cc refpclt.cc \
          derivedEcho_i.cc derivedEchoclt.cc \
          multiEcho_i.cc multiEchoclt.cc \
          attrEcho_i.cc attrEchoclt.cc \
          attrObjRef_i.cc attrObjRefclt.cc \
	  seqEcho_i.cc seqEchoclt.cc \
          conclt.cc consrv.cc

.first
	@ $(FIRSTACTIONS)
	@ define/nolog common [-.common]

COMMON_OBJS = [-.common]common$(DebugSuffix).olb

CORBA_INTERFACES = echo tstexcept refp derivedEcho attrEcho \
                   attrObjRef multiEcho seqEcho

CORBA_STUB_OBJS = $(CORBA_STUB_DIR)echoSK.obj,$(CORBA_STUB_DIR)tstexceptSK.obj,\
$(CORBA_STUB_DIR)refpSK.obj,$(CORBA_STUB_DIR)derivedEchoSK.obj,$(CORBA_STUB_DIR)attrEchoSK.obj,\
$(CORBA_STUB_DIR)attrObjRefSK.obj,$(CORBA_STUB_DIR)multiEchoSK.obj,$(CORBA_STUB_DIR)seqEchoSK.obj

OBJ_LIBS = $(COMMON_OBJS) $(CORBA_LIB)
OBJ_LIB_DEPEND = $(CORBA_STUB_OBJS) $(COMMON_OBJS) $(CORBA_LIB_DEPEND)

echoclt        = echoclt$(DebugSuffix).exe
echosrv        = echosrv$(DebugSuffix).exe
nullechoclt    = nullechoclt$(DebugSuffix).exe
tstexceptclt   = tstexceptclt$(DebugSuffix).exe
tstexceptsrv   = tstexceptsrv$(DebugSuffix).exe
refpclt        = refpclt$(DebugSuffix).exe
refpsrv        = refpsrv$(DebugSuffix).exe
derivedEchoclt = derivedEchoclt$(DebugSuffix).exe
derivedEchosrv = derivedEchosrv$(DebugSuffix).exe
attrEchoclt    = attrEchoclt$(DebugSuffix).exe
attrEchosrv    = attrEchosrv$(DebugSuffix).exe
attrObjRefclt  = attrObjRefclt$(DebugSuffix).exe
attrObjRefsrv  = attrObjRefsrv$(DebugSuffix).exe
multiEchoclt   = multiEchoclt$(DebugSuffix).exe
multiEchosrv   = multiEchosrv$(DebugSuffix).exe
seqEchoclt     = seqEchoclt$(DebugSuffix).exe
seqEchosrv     = seqEchosrv$(DebugSuffix).exe
conclt     = conclt$(DebugSuffix).exe
consrv     = consrv$(DebugSuffix).exe

all :: $(CORBA_STUB_OBJS) $(echoclt) $(echosrv) $(nullechoclt) $(tstexceptclt) \
	$(tstexceptsrv) $(refpclt) $(refpsrv) $(derivedEchoclt) \
	$(derivedEchosrv) $(multiEchoclt) $(multiEchosrv) $(attrEchoclt) \
	$(attrEchosrv) $(attrObjRefclt) $(attrObjRefsrv) $(multiEchoclt) \
	$(multiEchosrv) $(seqEchoclt) $(seqEchosrv) $(conclt) $(consrv) \
	$(nullechoclt)
      @ !

clean ::
	@ $(RM) $(echoclt) $(echosrv) $(tstexceptclt) $(tstexceptsrv)
	@ $(RM) $(refpclt) $(refpsrv) $(derivedEchoclt) $(derivedEchosrv)
	@ $(RM) $(multiEchoclt) $(multiEchosrv) $(attrEchoclt) $(attrEchosrv)
	@ $(RM) $(attrObjRefclt) $(attrObjRefsrv) $(multiEchoclt) $(multiEchosrv)
	@ $(RM) $(seqEchoclt) $(seqEchosrv) $(conclt) $(consrv) $(nullechoclt)

$(CORBA_STUB_OBJS) ::
	@ $(BuildCorbaStubs)

$(echoclt) : echoclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(echosrv) : echo_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(nullechoclt) : nullecho.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(tstexceptclt) : tstexceptclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(tstexceptsrv) : tstexcept_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(refpclt) : refpclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(refpsrv) : refp_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(derivedEchoclt) : derivedEchoclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(derivedEchosrv) : derivedEcho_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(multiEchoclt) : multiEchoclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(multiEchosrv) : multiEcho_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(attrEchoclt) : attrEchoclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(attrEchosrv) : attrEcho_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(attrObjRefclt) : attrObjRefclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(attrObjRefsrv) : attrObjRef_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(seqEchoclt) : seqEchoclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(seqEchosrv) : seqEcho_i.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(conclt) : conclt.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

$(consrv) : consrv.obj $(OBJ_LIB_DEPEND)
	@ $(CXXExecutable) $(CORBA_STUB_OBJS)

.endif	! INITIALIZE_MMS is defined
